import numpy as np
from modshogun import RealFeatures
from modshogun import RealSubsetFeatures
from modshogun import MulticlassLabels
from modshogun import CSVFile
from modshogun import MulticlassAccuracy
from modshogun import SerializableAsciiFile
from modshogun import ShareBoost
from modshogun import WrappedObjectArray

f_feats_train = CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")
f_labels_test = CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat")

#![create_features]
features_train = RealFeatures(f_feats_train)
features_test = RealFeatures(f_feats_test)
labels_train = MulticlassLabels(f_labels_train)
labels_test = MulticlassLabels(f_labels_test)
#![create_features]

#![create_instance]
shareboost = ShareBoost(features_train, labels_train, 2)
#![create_instance]

#![train_and_apply]
shareboost.train()
features_test_sub = RealSubsetFeatures(features_test, shareboost.get_activeset())
labels_predict = shareboost.apply_multiclass(features_test_sub)
#![train_and_apply]

#![evaluate_accuracy]
eval = MulticlassAccuracy()
accuracy = eval.evaluate(labels_predict, labels_test)
#![evaluate_accuracy]

# additional integration testing variables
output = labels_predict.get_labels()

# Serialize output for integration testing (automatically generated)
__sg_storage = WrappedObjectArray()
__sg_storage_file = SerializableAsciiFile("shareboost.dat", 'w')
__sg_storage.append_wrapped_real(accuracy, "accuracy")
__sg_storage.append_wrapped_real_vector(output, "output")
__sg_storage.save_serializable(__sg_storage_file)
